
#include <stdio.h>

#include "binio.h"
#include "math.h"
#define DEBUG 0
main(int argc, char *argv[]){
  int i,j,k,it;
  char *name;
  double *x,*y,*z, *data;
  int n[3];
  int l,nt;
  int size;
  double time;
  double pi = 3.141592654;
  double hx,hy,hz,lx,ly,lz;
  double h;
  int nx,ny,nz;
  double c1[3],c2[3],c3[3];
  double a1,a2,a3;
  double r1,r2,r3,ain;
  double thresh=0;
  
  a1 = 1.0;
  a2 = 1.05;
  a3 = 0.95;

  ain = 0.7;

  c1[0] = -1.0012;
  c1[1]= -1.014111;
  c1[2] = -1.02131231;
  
  c2[0] = 1.0512121;
  c2[1]= 1.0456532;
  c2[2] = 1.0123125;
  
  c3[0] = 3.0;
  c3[1]= 0.0;  
  c3[2] = -3.0;
  
  if (argc < 4)  {
    printf("usage isotest name nx ny nz\n");
    return -1;
  }
  name = argv[1];
  sscanf(argv[2],"%d",&n[0]);
  sscanf(argv[3],"%d",&n[1]);
  sscanf(argv[4],"%d",&n[2]);
  
  nt = 1;

  size = n[0]*n[1]*n[2];
  
  x = (double *)malloc(n[0]*sizeof(double));
  y = (double *)malloc(n[1]*sizeof(double));
  z = (double *)malloc(n[2]*sizeof(double));

  data = (double *)malloc(size*sizeof(double));
  
  lx = 8;
  ly = 8;
  lz = 8;
  hx = 2*lx/(n[0]-1);
  hy = 2*lx/(n[1]-1);
  hz = 2*lx/(n[2]-1);  
  nx = n[0];
  ny = n[1];
  nz = n[2];

  for (i=0;i<n[0];i++) {
    x[i] = -lx + hx*i;
  }
  for (i=0;i<n[1];i++) {
    y[i] = -ly + hy*i;
  }
  for (i=0;i<n[2];i++) {
    z[i] = -lz + hz*i; 
  }
  l = 0;
  if (DEBUG) printf("ain = %lf,%lf %lf %lf %lf %lf %lf %lf %lf %lf\n",ain,c1[0],c1[1],c1[2],c2[0],c2[1],c2[2],c3[0],c3[1],c3[2]);
  for (it=0;it<nt;it++) {
    /*strcpy(name,"scott");*/
    time = (double)it;
    for (k=0;k<n[2];k++) {
      for (j=0;j<n[1];j++) {
	for (i=0;i<n[0];i++) {
/* 	  r1 = sqrt( pow((x[i]-c1[0]),2)+pow((y[j]-c1[1]),2)+pow((z[k]-c1[2]),2)); */
	  r1 = (x[i]-c1[0])*(x[i]-c1[0])+(y[j]-c1[1])*(y[j]-c1[1])+(z[k]-c1[2])*(z[k]-c1[2]);
	  r2 = (x[i]-c2[0])*(x[i]-c2[0])+(y[j]-c2[1])*(y[j]-c2[1])+(z[k]-c2[2])*(z[k]-c2[2]);
	  r3 = (x[i]-c3[0])*(x[i]-c3[0])+(y[j]-c3[1])*(y[j]-c3[1])+(z[k]-c3[2])*(z[k]-c3[2]);
	  r1 = sqrt(r1);
	  r2 = sqrt(r2);
	  r3 = sqrt(r3);
/* 	  r2 = sqrt( pow((x[i]-c2[0]),2)+pow((y[j]-c2[1]),2)+pow((z[k]-c2[2]),2)); */
/* 	  r3 = sqrt( pow((x[i]-c3[0]),2)+pow((y[j]-c3[1]),2)+pow((z[k]-c3[2]),2)); */
	  if (DEBUG) printf("%lf %lf %lf\n",r1,r2,r3);
	  if (r1 < ain) r1=ain;
	  if (r2 < ain) r2=ain;
	  if (r3 < ain) r3=ain;

	  data[l] = exp(-time) * ( a1/r1 + a2/r2 + a3/r3);
	  thresh+=data[l];
	  if (DEBUG) printf("%d %d %d %lf %lf %lf %lf %lf %lf\n",i,j,k,x[i],y[j],z[k],r1,r2,data[l]);
	  l++;
	}
      }
    }
    thresh/=size;
    if (DEBUG)printf("thesh=%lf\n",thresh);
    printf("sending data\n");
    avs_rect(name, time, n,x, y, z, data);  
    printf("done sending data\n");
  }
}
